#!/bin/bash



#in.telnetd installer v1.0



# Controll LED.
/usr/local/bin/ledcont cycle 8
/usr/local/bin/ledcont pwrblink



# Stop Daemons.
/home/LANDISK/scripts/killftpd.sh stop
/etc/rc.d/init.d/S99reset_daemon stop
/etc/rc.d/init.d/S92netatalk stop
/etc/rc.d/init.d/S91samba stop
# /etc/rc.d/init.d/S95httpd stop
/etc/rc.d/init.d/S90identd stop
/etc/rc.d/init.d/S60lpd stop
/etc/rc.d/init.d/S40cron stop
/etc/rc.d/init.d/S35dhcpcd stop
/etc/rc.d/init.d/S20network stop
/etc/rc.d/init.d/S15inet stop



# Remount root in rw-mode.
mount -o remount,rw %root% /
if [ $? != 0 ]; then
	/usr/local/bin/ledcont accblink
	/usr/local/bin/ledcont pwrblink
	/usr/local/sbin/leddrv_unload
	exit 1
fi



# Backup setting files
for n in hosts.allow hosts.deny inetd.conf securetty sudoers; do
	f=/etc/$n
	if [ -f $f ]; then
		/bin/cp $f $f.backup
		if [ $? != 0 ]; then
			/usr/local/bin/ledcont accblink
			/usr/local/bin/ledcont pwrblink
			/usr/local/sbin/leddrv_unload
			exit 1
		fi
	fi
done



# Add sudoers
s='/etc/sudoers'
if [ -f $s -a $(/usr/bin/grep -c landisk $s) = 0 ]; then
	echo '' >> $s
	echo 'landisk	ALL=(ALL)	ALL' >> $s
fi



# Copy Files.
tar xpzf /mnt/hda3/.landisk-update/update-files.tar.gz -C /
if [ $? != 0 ]; then
	/usr/local/bin/ledcont accblink
	/usr/local/bin/ledcont pwrblink
	/usr/local/sbin/leddrv_unload
	exit 1
fi



# Remount root in ro-mode.
sync
mount -o remount,ro %root% /



# Remove updator files
rm -rf /mnt/hda3/.landisk-update/update.tgz
rm -rf /mnt/hda3/.landisk-update/update-files.tar.gz



# Reboot
sync
mount -o remount,ro /dev/hda3 /mnt/hda3
/home/LANDISK/scripts/powerctrl.sh reboot


exit 0
